#ifndef H_FILES_H
#define H_FILES_H
#include <basedef.h>
#include <VXDWRAPS.H>
#include <vmm.h>
#include <minivdd.H>
#include <shell.h>
#include <ifs.h>

typedef struct  _WIN32_FIND_DATAA{ //That is *NOT* the structure which is used from the IFS -> Driver, but the Driver -> R0_FileInterface
    DWORD dwFileAttributes;
    _FILETIME ftCreationTime;
    _FILETIME ftLastAccessTime;
    _FILETIME ftLastWriteTime;
    DWORD nFileSizeHigh;
    DWORD nFileSizeLow;
    DWORD dwReserved0;
    DWORD dwReserved1;
    CHAR   cFileName[ MAX_PATH ];
    CHAR   cAlternateFileName[ 14 ];
} WIN32_FIND_DATAA, *PWIN32_FIND_DATAA;

extern void IFSMgr_InstallFileSystemApiHookWrap(); //Wrapper in ASM
extern void IFSMgr_RemoveFileSystemApiHookWrap();
extern void IFSMgr_Ring0_FileIOWrap();
extern void UniToBCSPathWrap(); 


//File interface
short IFSR0WriteFile(DWORD handleEBX, int writeFuncEAX, int writeCountECX, int startPosEDX, char * bufferESI, int * result);
short IFSR0ReadFile(DWORD handleEBX, int readFuncEAX, int readCountECX, int startPosEDX, char/*void*/ * bufferESI, int * result);
int IFSR0CloseFile(DWORD handle);
DWORD IFSR0OpenFile(const char * fileNameESI, int openFunctionEAX, unsigned short openModeBX, unsigned short attribsCX, unsigned char actionDL, unsigned char optionsDH, DWORD * handle, unsigned short * action)	;
short IFSR0GetFileAttributes(char * fileName, short * attrib)	;
int IFSR0FindCloseFile(DWORD handle);
int IFSR0FindNextFile(WIN32_FIND_DATAA * findResult, DWORD handle);
int IFSR0FindNextFile(WIN32_FIND_DATAA * findResult, DWORD handle);
short IFSR0FindFirstFile(short attributes, char * path, WIN32_FIND_DATAA * findResult, DWORD * handle);
short IFSR0GetFileSize(DWORD handleEBX,int * size);
short GetFileTimes(char * fileName, dos_time * access, dos_time * change, dos_time * create);
short GetFileSize(char * name,int * size);
BOOL ExistDirectory(char * dir);

//IFS Interface
pIFSFileHookFunc IFSMgr_InstallFileSystemApiHookCWrap(pIFSFileHookFunc newFunc);
void IFSMgr_RemoveFileSystemApiHookCWrap(pIFSFileHookFunc func);

//Converter/Pathfuncs
int UniToBCSPathDrive(char * pBCSPath, ParsedPath * pUniPath, unsigned int maxLength, int charSet, int drive);
int UniToBCSPathCWrap(/*unsigned*/ char * pBCSPath, ParsedPath * pUniPath, unsigned int maxLength, int charSet) ;
void cpyAnsiFindDataToUni(const WIN32_FIND_DATAA *in, _WIN32_FIND_DATA * out);
void BCSToUniPath(char * bcs, ParsedPath ** uni, BOOL swapable);
BOOL isDOSPath(ParsedPath * ppath);
BOOL convertLastLFNElementToDOS(char * bcsInPath, char ** bcsOutPath, BOOL swapable);
BOOL convertLastLFNElementToDOSUni(ParsedPath * inpp,ParsedPath ** outpp, int drive);
void Win32TimeToDosTime(_FILETIME * w32in, dos_time * dosOut);


#endif