//Copyright (C) 2004 Benito van der Zander
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "vmmwrap2.h"
//64 bit calculating
void n64Div32(number64 * a, unsigned long b){
  long higha=a->high;
  long lowa=a->low;
  __asm{
    mov edi, higha
    mov esi, lowa
    mov ecx, b

    xor edx,edx
    mov eax,edi
    div ecx
    mov edi,eax
    mov eax,esi
    div ecx

    mov higha, edi
    mov lowa, eax
  }  
  a->high=higha;
  a->low=lowa;
}  
void n64Sub32(number64 * a, unsigned long b){
  if (a->low>=b) a->low-=b;
  else {
    a->low=0xFFFFFFFF - b+1;
    a->high--;
  }  
}  
//converter functions
void IntToStr( char * result, unsigned int in){
  int i;
  result[10]='\0';
  result=result+9;
  for (i=0;i<10;i++){
    if ((in>0)||(i==0)) {
      *result=(char)(max(0,min((char)(in % 10),9))+'0');
      result--;
      in/=10;
    } else {
      *result=' ';
      result--;
    }
  }
}
void cpyAnsiToUniStrN(unsigned short * out, const char * in, const int len){
  int i;
  for (i=0;i<len;i++) out[i]=in[i];
}
int cpyAnsiToUniStr(unsigned short * out, const char * in){
  int i;
  for (i=0;in[i]!='\0';i++) out[i]=in[i];
  return i;
}
int UniToBCSCWrap(char * bcs, unsigned short * uni, int len, int maxLen, int charset){
  int result;
  __asm {
    mov eax, charset
    mov ecx, maxLen
    mov edx, len
    mov esi, uni
    mov edi, bcs
    call UniToBCSWrap;
    mov result, eax
  }  
  return result;
}
int UniToBCSAuto(char * bcs, unsigned short * uni, int maxLen){
  int len=0;
  for (len=0;(len<=maxLen);len++) if (uni[len]==0) break;
  
  return UniToBCSCWrap(bcs,uni,len,maxLen,BCS_WANSI);
}
int BCSToUniCWrap(const char * bcs, unsigned short * uni, int len, int charset){
  int result;
  __asm {
    mov eax, charset
    mov ecx, len
    mov esi, bcs
    mov edi, uni
    call BCSToUniWrap;
    mov result, eax
  }  
  return result;
}
int BCSToUniAuto(const char * bcs, unsigned short * uni){
  int len=0;
  for (len=0;(bcs[len]!=0);len++);
  if (len==0) return 0;
  len = BCSToUniCWrap(bcs,uni,len,BCS_WANSI);
  return len;
}

//message functions
void showMessage(DWORD flags, char * message, char * title){
  DWORD handle=0;
  VMMCall(Get_Cur_VM_Handle);
  flags|=MB_ASAP;
  __asm {mov handle, ebx};
  SHELL_SYSMODAL_Message(handle,flags,message,title);
}
void ShowIntMessage(DWORD flags, int message, char * title){
  char buf[11]="abcdefghij";
  IntToStr(&buf[0],message);
  showMessage(flags,&buf[0],title);
}

//Memory functions
void MemoryLock( ULONG startAddr,  ULONG len){
  startAddr=startAddr>>12; //delete offset 
  len=(len>>12)+1;
  __asm{
    mov eax, startAddr
    mov ecx, len
    call LinPageLockWrap
  }  
}  
void MemoryUnLock(ULONG startAddr, ULONG len){
  startAddr=startAddr>>12; //delete offset 
  len=(len>>12)+1;
  __asm{
    mov eax, startAddr
    mov ecx, len
    call LinPageUnLockWrap
  }  
}  
ULONG halloc(ULONG bytes, ULONG flags){
  ULONG result;
  __asm{
    push flags
    push bytes
  }  
  VMMCall(_HeapAllocate);
  __asm{
    pop ecx
    pop ecx
    mov result, eax
  }  
}  
void hfree(ULONG address){
  __asm {
    push 0
    push address
  }  
  VMMCall(_HeapFree);
  __asm {
    pop ecx
    pop ecx
  }  
}  
void copyMemory(const char * source, char * dest, const unsigned int count){
  unsigned int i;
  for (i=0;i<count;i++) dest[i]=source[i];
}  
void cpyStrN(char * out, const char * in, const int len){
  int i;
  for (i=0;i<len;i++) out[i]=in[i];
}
//mutex handling
DWORD CreateMutex(LONG Boost, ULONG Flags)
{
  DWORD result;
  __asm { 
    push Flags
    push Boost
  }
  VMMCall(_CreateMutex);
  __asm {
    pop ecx
    pop ecx
    mov result, eax
  }
  return result;
}
void EnterMutex(DWORD MutexHandle, DWORD Flags)
{
  _asm   push Flags
  _asm   push MutexHandle
  VMMCall(_EnterMutex);
  _asm   pop eax
  _asm   pop eax
}

void LeaveMutex(DWORD hmtx)
{
  _asm   push hmtx
  VMMCall(_LeaveMutex);
  _asm   pop eax
}
void DestroyMutex(DWORD hmtx)
{
  _asm   push hmtx
  VMMCall(_DestroyMutex);
  _asm   pop eax
}

