#ifndef hvmmwrap2h
#define hvmmwrap2h

#include <basedef.h>
#include <VXDWRAPS.H>
#include <vmm.h>
#include <minivdd.H>
#include <shell.h>
#include <ifs.h>

extern void UniToBCSWrap(); //Wrapper in ASM
extern void BCSToUniWrap();

typedef struct _number64{
  unsigned long low;
  unsigned long high;
} number64;

void n64Div32(number64 * a, unsigned long b);
void n64Sub32(number64 * a, unsigned long b);

//convert functions
void IntToStr( char * result, unsigned int in);
void cpyAnsiToUniStrN(unsigned short * out, const char * in, const int len);
int cpyAnsiToUniStr(unsigned short * out, const char * in);
int UniToBCSCWrap(char * bcs, unsigned short * uni, int len, int maxLen, int charset);
int UniToBCSAuto(char * bcs, unsigned short * uni, int maxLen);
int BCSToUniCWrap(const char * bcs, unsigned short * uni, int len, int charset);
int BCSToUniAuto(const char * bcs, unsigned short * uni);
//messages
#define MB_ERROR (MB_OK|MB_SYSTEMMODAL|MB_ICONEXCLAMATION|MB_ASAP)
#define SimpleMessage(str) showMessage(MB_OK | MB_ASAP,(str),"CRS Simple Message")
void showMessage(DWORD flags, char * message, char * title);
void ShowIntMessage(DWORD flags, int message, char * title);

//memory
extern void LinPageLockWrap();
extern void LinPageUnLockWrap();
void MemoryLock( ULONG startAddr,  ULONG len);
void MemoryUnLock(ULONG startAddr, ULONG len);
ULONG halloc(ULONG bytes, ULONG flags);
void  hfree(ULONG address);
void copyMemory(const char * source, char * dest, const unsigned int count);
void cpyStrN(char * out, const char * in, const int len);
//mutex
#ifdef DEBUG
#define EnterMutex_ EnterMutex(mutex,BLOCK_ENABLE_INTS | BLOCK_SVC_INTS);writeLogFile("enter mutex",11)
#define LeaveMutex_ LeaveMutex(mutex);writeLogFile("leave mutex",11)
#else
#define EnterMutex_ EnterMutex(mutex,BLOCK_ENABLE_INTS | BLOCK_SVC_INTS)
#define LeaveMutex_ LeaveMutex(mutex)
#endif;
DWORD CreateMutex(LONG Boost, ULONG Flags);
void EnterMutex(DWORD MutexHandle, DWORD Flags);
void LeaveMutex(DWORD hmtx);
void DestroyMutex(DWORD hmtx);
#endif
